#ifndef __KP_MAIN_WINDOW_H
#define __KP_MAIN_WINDOW_H

#include <gtk/gtk.h>
#include "../kptraininglog.h"

#define KP_TYPE_MAIN_WINDOW         (kp_main_window_get_type ())
#define KP_MAIN_WINDOW(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), KP_TYPE_MAIN_WINDOW, KPMainWindow))
#define KP_MAIN_WINDOW_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), KP_TYPE_MAIN_WINDOW, KPMainWindowClass))
#define KP_IS_MAIN_WINDOW(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), KP_TYPE_MAIN_WINDOW))
#define KP_IS_MAIN_WINDOW_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), KP_TYPE_MAIN_WINDOW))
#define KP_MAIN_WINDOW_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), KP_TYPE_MAIN_WINDOW, KPMainWindowClass))

typedef struct
{
  GtkWindow       parent;

  gpointer        private_data;
} KPMainWindow;

typedef struct
{
  GtkWindowClass  parent_class;
} KPMainWindowClass;

GType              kp_main_window_get_type              (void);

GtkWidget         *kp_main_window_new                   (void);
 
void               kp_main_window_set_log_file          (KPMainWindow *window,
                                                         const gchar *file);
KPTrainingLog     *kp_main_window_get_log               (void);

GtkWidget         *kp_main_window_add_to_import_menu    (GtkMenuItem *item);
GtkWidget         *kp_main_window_add_to_export_menu    (GtkMenuItem *item);
GtkWidget         *kp_main_window_add_to_menubar        (GtkMenu *menu);

#endif
